package com.cmx.hydrology.activity

import android.graphics.Bitmap
import android.os.Bundle
import android.webkit.WebResourceError
import android.webkit.WebResourceRequest
import android.webkit.WebSettings
import android.webkit.WebView
import android.webkit.WebViewClient
import androidx.appcompat.app.AppCompatActivity
import com.cmx.hydrology.utils.AndroidtoJs
import com.cmx.hydrology.view.BaseLoadingDialog
import com.lsxiao.apollo.core.Apollo
import com.lsxiao.apollo.core.contract.ApolloBinder

open class BaseActivity : AppCompatActivity() {
    private var mBaseLoadingDialog: BaseLoadingDialog? = null
    private var mApolloBinder: ApolloBinder? = null
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        mBaseLoadingDialog = BaseLoadingDialog(this)
        mApolloBinder = Apollo.bind(this)
    }

    fun showDialog() {
        if (!mBaseLoadingDialog!!.isShowing) {
            mBaseLoadingDialog!!.show()
        }
    }

    fun disDialog() {
        if (mBaseLoadingDialog!!.isShowing) {
            mBaseLoadingDialog!!.dismiss()
        }
    }

    fun setWeb(mWebView: WebView) {
        val webSettings = mWebView!!.settings
        webSettings.javaScriptEnabled = true
        webSettings.cacheMode = WebSettings.LOAD_NO_CACHE
        webSettings.domStorageEnabled = true
        mWebView!!.addJavascriptInterface(AndroidtoJs(), "AndroidtoJs")
        mWebView.webViewClient = object : WebViewClient() {
            override fun onPageStarted(view: WebView?, url: String?, favicon: Bitmap?) {
                super.onPageStarted(view, url, favicon)
                showDialog()
            }

            override fun shouldOverrideUrlLoading(view: WebView, url: String): Boolean {
                //使用WebView加载显示url
                view.loadUrl(url)
                //返回true
                return true
            }

            override fun onPageFinished(view: WebView, url: String) {
                disDialog()
            }

            override fun onReceivedError(view: WebView, request: WebResourceRequest, error: WebResourceError) {
                disDialog()
            }
        }
    }

    override fun onDestroy() {
        super.onDestroy()
        if (mApolloBinder != null) {
            mApolloBinder!!.unbind()
        }
    }

    companion object {
        private const val TAG = "BaseActivity"
    }
}