package com.cmx.hydrology.retrofit

import android.util.Log
import com.cmx.hydrology.activity.MyApplication.Companion.getmInstance
import com.cmx.hydrology.constant.Events
import com.cmx.hydrology.utils.SpUtils
import com.google.gson.reflect.TypeToken
import okhttp3.OkHttpClient
import okhttp3.ResponseBody
import okhttp3.logging.HttpLoggingInterceptor
import retrofit2.Call
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory
import java.util.concurrent.TimeUnit

/**
 * Created by TTLock on 2018/9/5.
 */
object RetrofitAPIManager {
    fun provideClientApi(): ApiService {
        val retrofit = Retrofit.Builder().client(genericClient()).baseUrl(Events.SERVER_URL)
            .addConverterFactory(GsonConverterFactory.create()).build()
        return retrofit.create(ApiService::class.java)
    }

    fun genericClient(): OkHttpClient {
        val interceptor = HttpLoggingInterceptor { message ->
            //                try {
            //                    String text = URLDecoder.decode(message, "utf-8");
            //                    Log.e("OKHttp-----", text);
            //                } catch (UnsupportedEncodingException e) {
            //                    e.printStackTrace();
            Log.e("OKHttp-----", message)
            //                }
        }
        interceptor.level = HttpLoggingInterceptor.Level.BODY
        return OkHttpClient.Builder().connectTimeout(35, TimeUnit.SECONDS).readTimeout(35, TimeUnit.SECONDS)
            .writeTimeout(35, TimeUnit.SECONDS).addInterceptor(interceptor).addInterceptor { chain ->
                val original = chain.request()
                val requestBuilder =
                    original.newBuilder().header("token", SpUtils.getString(getmInstance()!!, "token"))
                val request = requestBuilder.build()
                chain.proceed(request)
            }.build()
    }

    fun <T> enqueue(
        call: Call<ResponseBody?>?,
        resultType: TypeToken<T>?,
        listener: ApiResponse.Listener<ApiResult<T>?>?,
        errorListener: ApiResponse.ErrorListener?
    ): ApiRequtest<*> {
        return ApiRequtest(call!!, resultType!!, listener!!, errorListener!!)
    }
}